
#include <target/io.h>
#include <target/herrno.h>

#include <target/net/mac.h>
#include <target/net/eth_util.h>

static int mac_cmdfunc(int argc, char *argv[]){
  unsigned char mac[6];
  int ret;
    
  ret = arch_get_mac(mac);
  if(ret == -1){
    hprintf("command failed\n");
    return -1;
  }
  print_mac(mac);

  return 0;
}

static int setmac_cmdfunc(int argc, char *argv[]){
  unsigned char mac[6];
  unsigned char num;
  int ptr;
  int i;

  if(argc < 2) return -H_EUSAGE;

  for(i=0, ptr=0; argv[1][i] != 0; i++){
    switch(argv[1][i]){
    case '0': case '1': case '2': case '3': case '4':
    case '5': case '6': case '7': case '8': case '9':
      num = argv[1][i] - '0';
      break;
    case 'A': case 'B': case 'C': case 'D': case 'E': case 'F':
      num = argv[1][i] - 'A' + 10;
      break;
    case 'a': case 'b': case 'c': case 'd': case 'e': case 'f':
      num = argv[1][i] - 'a' + 10;
      break;
    case ':': case '.':
      continue;
    default:
      return -H_EUSAGE;
    }

    if(ptr % 2){
      mac[ptr/2] |= num;
    }else{
      mac[ptr/2] = (num << 4);
    }
    ptr++;
  }

  if(ptr != 12) return -H_EADDR;
  print_mac(mac);

  arch_set_mac(mac);
  
  return 0;
}

const command_t mac_command =
        { "mac", 0, "display mac address", &mac_cmdfunc };

const command_t setmac_command =
	{ "setmac", "<mac>", "set mac address", &setmac_cmdfunc };




